## libthrust 1.15.0

=== CMakeLists.txt ===
# 3.15 is the minimum for including the project with add_subdirectory.
# 3.17 for building the project's standalone tests/examples/etc.
# 3.18.3 for C++17 + CUDA
cmake_minimum_required(VERSION 3.15)

# Remove this when we use the new CUDA_ARCHITECTURES properties with both
# nvcc and nvc++.
if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.18)
  cmake_policy(SET CMP0104 OLD)
endif()

project(Thrust NONE)

# Determine whether Thrust is the top-level project or included into
# another project via add_subdirectory()
if ("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_LIST_DIR}")
  set(THRUST_TOPLEVEL_PROJECT ON)
else()
  set(THRUST_TOPLEVEL_PROJECT OFF)
endif()

# This must be done before any languages are enabled:
if (THRUST_TOPLEVEL_PROJECT)
  include(cmake/ThrustCompilerHacks.cmake)
endif()

# This must appear after our Compiler Hacks or else CMake will delete the cache
# and reconfigure from scratch.
# This must also appear before the installation rules, as it is required by the
# GNUInstallDirs CMake module.
enable_language(CXX)

# Optionally include installation rules for non-top-level builds:
option(THRUST_ENABLE_INSTALL_RULES "Enable installation of Thrust" ${THRUST_TOPLEVEL_PROJECT})
if (THRUST_ENABLE_INSTALL_RULES)
  include(cmake/ThrustInstallRules.cmake)
endif()

# Support adding Thrust to a parent project via add_subdirectory.
# See examples/cmake/add_subdir/CMakeLists.txt for details.
if (NOT THRUST_TOPLEVEL_PROJECT)
  include(cmake/ThrustAddSubdir.cmake)
  return()
endif()

# We use 3.17 features when building our tests, etc.
cmake_minimum_required(VERSION 3.17)

option(THRUST_ENABLE_HEADER_TESTING "Test that all public headers compile." "ON")
option(THRUST_ENABLE_TESTING "Build Thrust testing suite." "ON")
option(THRUST_ENABLE_EXAMPLES "Build Thrust examples." "ON")
option(THRUST_INCLUDE_CUB_CMAKE "Build CUB tests and examples. (Requires CUDA)." "OFF")

# Check if we're actually building anything before continuing. If not, no need
# to search for deps, etc. This is a common approach for packagers that just
# need the install rules. See GH issue NVIDIA/thrust#1211.
if (NOT (THRUST_ENABLE_HEADER_TESTING OR
         THRUST_ENABLE_TESTING OR
         THRUST_ENABLE_EXAMPLES OR
         THRUST_INCLUDE_CUB_CMAKE))
  return()
endif()

include(cmake/AppendOptionIfAvailable.cmake)
include(cmake/ThrustBuildCompilerTargets.cmake)
include(cmake/ThrustBuildTargetList.cmake)
include(cmake/ThrustFindThrust.cmake)
include(cmake/ThrustMultiConfig.cmake)
include(cmake/ThrustUtilities.cmake)

# Add cache string options for CMAKE_BUILD_TYPE and default to RelWithDebInfo.
if ("" STREQUAL "${CMAKE_BUILD_TYPE}")
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Choose the type of build." FORCE)

  set_property(
    CACHE CMAKE_BUILD_TYPE
    PROPERTY STRINGS Debug Release RelWithDebInfo MinSizeRel
  )
endif ()

# Disable compiler extensions:
set(CMAKE_CXX_EXTENSIONS OFF)

# Where to put build outputs. Use CMAKE_BINARY_DIR so they'll show up in the
# top-level project's dir when building Thrust via add_subdirectory.
set(THRUST_LIBRARY_OUTPUT_DIR "${CMAKE_BINARY_DIR}/lib")
set(THRUST_EXECUTABLE_OUTPUT_DIR "${CMAKE_BINARY_DIR}/bin")

thrust_configure_multiconfig()
thrust_find_thrust()
thrust_build_compiler_targets()
thrust_update_system_found_flags()
if (THRUST_CUDA_FOUND)
  include(cmake/ThrustCudaConfig.cmake)
endif()
thrust_build_target_list()

message(STATUS "CPP system found?  ${THRUST_CPP_FOUND}")
message(STATUS "CUDA system found? ${THRUST_CUDA_FOUND}")
message(STATUS "TBB system found?  ${THRUST_TBB_FOUND}")
message(STATUS "OMP system found?  ${THRUST_OMP_FOUND}")

if (THRUST_ENABLE_HEADER_TESTING)
  include(cmake/ThrustHeaderTesting.cmake)
endif()

# Both testing and examples use ctest
if (THRUST_ENABLE_TESTING OR THRUST_ENABLE_EXAMPLES)
  include(CTest)
  enable_testing()
endif()

if (THRUST_ENABLE_TESTING)
  add_subdirectory(testing)
endif()

if (THRUST_ENABLE_EXAMPLES)
  add_subdirectory(examples)
endif()

if (THRUST_INCLUDE_CUB_CMAKE AND THRUST_CUDA_FOUND)
  set(CUB_IN_THRUST ON)
  # CUB's path is specified generically to support both GitHub and Perforce
  # source tree layouts. The include directory used by cub-config.cmake
  # for source layouts is the same as the project root.
  add_subdirectory("${_CUB_INCLUDE_DIR}" dependencies/cub)
endif()

=== testing/cmake/CMakeLists.txt ===
thrust_update_system_found_flags()

set(extra_cmake_flags)

# Need to pass these when testing NVC++.
if ("NVCXX" STREQUAL "${CMAKE_CUDA_COMPILER_ID}")
  set(extra_cmake_flags
    -D "CMAKE_CUDA_COMPILER_ID=${CMAKE_CUDA_COMPILER_ID}"
    -D "CMAKE_CUDA_COMPILER_FORCED=${CMAKE_CUDA_COMPILER_FORCED}"
  )
endif()

if (THRUST_CPP_FOUND AND THRUST_CUDA_FOUND)
  # Test that we can use `find_package` on an installed Thrust:
  add_test(
    NAME thrust.test.cmake.test_install
    COMMAND "${CMAKE_COMMAND}"
      --log-level=VERBOSE
      -G "${CMAKE_GENERATOR}"
      -S "${CMAKE_CURRENT_SOURCE_DIR}/test_install"
      -B "${CMAKE_CURRENT_BINARY_DIR}/test_install"
      -D "THRUST_BINARY_DIR=${Thrust_BINARY_DIR}"
      -D "CMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
      -D "CMAKE_CUDA_COMPILER=${CMAKE_CUDA_COMPILER}"
      -D "CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}"
      ${extra_cmake_flags}
  )
endif()

# Check source code for issues that can be found by pattern matching:
add_test(
  NAME thrust.test.cmake.check_source_files
  COMMAND
    "${CMAKE_COMMAND}"
      -D "Thrust_SOURCE_DIR=${Thrust_SOURCE_DIR}"
      -P "${CMAKE_CURRENT_LIST_DIR}/check_source_files.cmake"
)

=== debian/changelog ===
libthrust (1.15.0-1) unstable; urgency=medium

  * New upstream release 1.15.0 (CUDA 11.6).
  * Recommend libtbb-dev.
  * Tighten cub dependency.  (Closes: #1006226)
  * Use upstream build system for installation.
  * Add superficial autopkgtest for cmake find_package(Thrust).
  * Add superficial autopkgtest running (CPP, TBB, OMP) or compiling (CUDA)
    the upstream testsuite for C++-14 and C++17 (requires
    nvidia-cuda-toolkit/non-free).
    (Running the CUDA testsuite would require a CUDA capable CPU and using the
    kernel module from nvidia-graphics-drivers/non-free.)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 01 Mar 2022 20:51:54 +0100

=== debian/control ===
Source: libthrust
Section: libdevel
Priority: optional
Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Beckmann <anbe@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://github.com/NVIDIA/thrust
Vcs-Browser: https://salsa.debian.org/nvidia-team/libthrust
Vcs-Git: https://salsa.debian.org/nvidia-team/libthrust.git

Package: libthrust-dev
Architecture: all
Multi-Arch: foreign
Depends:
 libcub-dev (>= ${cub:Version}),
 libcub-dev (<< ${cub:Version}.),
 ${misc:Depends}
Recommends:
 libtbb-dev,
Suggests: nvidia-cuda-toolkit
Description: Thrust - Parallel Algorithms Library
 Thrust is a parallel algorithms library which resembles the C++ Standard
 Template Library (STL). Thrust's high-level interface greatly enhances
 programmer productivity while enabling performance portability between GPUs
 and multicore CPUs. Interoperability with established technologies (such as
 CUDA, TBB, and OpenMP) facilitates integration with existing software.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --without single-binary --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DTHRUST_DEVICE_SYSTEM=CPP \
		-DTHRUST_CPP_DIALECT=17 \
		-DTHRUST_INSTALL_CUB_HEADERS=OFF \
		-Wno-dev

# for debhelper-compat (<< 15)
override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

execute_after_dh_auto_install:
	# remove empty directories
	find debian/tmp -depth -type d -exec sh -c 'd="{}"; rmdir --ignore-fail-on-non-empty "$$d" ; test -d "$$d" || echo "removed $$d"' \;

override_dh_gencontrol:
	dh_gencontrol -- -V'cub:Version=$(word 1,$(subst -, ,$(DEB_VERSION_UPSTREAM)))'

=== debian/tests/control ===
Test-Command: cmake -Wno-dev -S debian/tests/cmake -B $AUTOPKGTEST_TMP
Depends:
 @,
 cmake,
 g++,
 libtbb-dev,
Restrictions:
 superficial,

Test-Command: debian/tests/upstream-testsuite CPP
Depends:
 @,
 cmake,
 g++,
 libtbb-dev,
Restrictions:
 superficial,
 allow-stderr,
 flaky,

Test-Command: debian/tests/upstream-testsuite TBB
Depends:
 @,
 cmake,
 g++,
 libtbb-dev,
Restrictions:
 superficial,
 allow-stderr,

Test-Command: debian/tests/upstream-testsuite OMP
Depends:
 @,
 cmake,
 g++,
 libtbb-dev,
Restrictions:
 superficial,
 allow-stderr,
 flaky,

Test-Command: debian/tests/upstream-testsuite CUDA cuda-g++
Architecture: amd64 arm64 ppc64el
Depends:
 @,
 cmake,
 libtbb-dev,
 nvidia-cuda-toolkit-gcc,
Restrictions:
 superficial,
 allow-stderr,
 flaky,

Test-Command: debian/tests/upstream-testsuite CUDA g++-10
Architecture: amd64 arm64 ppc64el
Depends:
 @,
 cmake,
 libtbb-dev,
 g++-10,
 nvidia-cuda-toolkit,
Restrictions:
 superficial,
 allow-stderr,
 flaky,

## libthrust 1.16.0

=== debian/changelog ===
libthrust (1.16.0-1) unstable; urgency=medium

  * New upstream release 1.16.0.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 19 Jun 2022 20:27:00 +0200

libthrust (1.15.0-6) unstable; urgency=medium

  * Disable cuda tests on !amd64, they always run into timeout.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 05 Jun 2022 23:19:51 +0200

libthrust (1.15.0-5) unstable; urgency=medium

  * Avoid using '/' in autopkgtest names.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 02 Jun 2022 03:32:27 +0200

libthrust (1.15.0-4) unstable; urgency=medium

  * Reduce amount of autopkgtest tests.  (Closes: #1011646)

 -- Andreas Beckmann <anbe@debian.org>  Fri, 27 May 2022 06:20:52 +0200

libthrust (1.15.0-3) unstable; urgency=medium

  * Generate debian/tests/control from debian/tests/control.sh.
  * More fine-grained CUDA autopkgtests to avoid timeouts.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 25 May 2022 21:29:40 +0200

libthrust (1.15.0-2) unstable; urgency=medium

  * Add salsa-ci.yml.
  * Tune autopkgtests.
  * Bump Standards-Version to 4.6.1, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 24 May 2022 19:02:05 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  debhelper-compat (= 13),
  cmake,
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/NVIDIA/thrust
 Vcs-Browser: https://salsa.debian.org/nvidia-team/libthrust
 Vcs-Git: https://salsa.debian.org/nvidia-team/libthrust.git

=== debian/rules ===
--- 
+++ 
@@ -20,8 +20,15 @@
 	dh_auto_install --destdir=debian/tmp
 
 execute_after_dh_auto_install:
+	$(RM) -v debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/thrust/thrust-header-search.cmake.in
 	# remove empty directories
 	find debian/tmp -depth -type d -exec sh -c 'd="{}"; rmdir --ignore-fail-on-non-empty "$$d" ; test -d "$$d" || echo "removed $$d"' \;
 
 override_dh_gencontrol:
 	dh_gencontrol -- -V'cub:Version=$(word 1,$(subst -, ,$(DEB_VERSION_UPSTREAM)))'
+
+
+debian/tests/control: debian/tests/control.sh
+	sh $< > $@
+
+clean: debian/tests/control

=== debian/tests/control ===
Test-Command: cmake -Wno-dev -S debian/tests/cmake -B $AUTOPKGTEST_TMP
Features: test-name=cmake_find_package_Thrust
Depends:
 @,
 cmake,
 g++,
 libtbb-dev,
Restrictions:
 superficial,

Test-Command: debian/tests/upstream-testsuite CPP 17 g++-12
Features: test-name=run_testsuite_CPP_C++17_g++-12
Depends:
 @,
 cmake,
 make,
 libtbb-dev,
 g++-12,
Restrictions:
 superficial,
 allow-stderr,
 flaky,

Test-Command: debian/tests/upstream-testsuite CPP 17 g++-11
Features: test-name=run_testsuite_CPP_C++17_g++-11
Depends:
 @,
 cmake,
 make,
 libtbb-dev,
 g++-11,
Restrictions:
 superficial,
 allow-stderr,
 flaky,

Test-Command: debian/tests/upstream-testsuite CPP 17 g++-10
Features: test-name=run_testsuite_CPP_C++17_g++-10
Depends:
 @,
 cmake,
 make,
 libtbb-dev,
 g++-10,
Restrictions:
 superficial,
 allow-stderr,
 flaky,

Test-Command: debian/tests/upstream-testsuite CPP 14
Features: test-name=run_testsuite_CPP_C++14
Depends:
 @,
 cmake,
 make,
 libtbb-dev,
 g++,
Restrictions:
 superficial,
 allow-stderr,
 flaky,

Test-Command: debian/tests/upstream-testsuite TBB 17
Features: test-name=run_testsuite_TBB_C++17
Depends:
 @,
 cmake,
 make,
 libtbb-dev,
 g++,
Restrictions:
 superficial,
 allow-stderr,
 flaky,

Test-Command: debian/tests/upstream-testsuite CPP/CUDA 17 cuda-g++
Features: test-name=compile_testsuite_CPP_CUDA_C++17_cuda-g++
Architecture: amd64
Depends:
 @,
 cmake,
 make,
 libtbb-dev,
 nvidia-cuda-toolkit-gcc,
Restrictions:
 superficial,
 allow-stderr,

Test-Command: debian/tests/upstream-testsuite TBB/CUDA 17 cuda-g++
Features: test-name=compile_testsuite_TBB_CUDA_C++17_cuda-g++
Architecture: amd64
Depends:
 @,
 cmake,
 make,
 libtbb-dev,
 nvidia-cuda-toolkit-gcc,
Restrictions:
 superficial,
 allow-stderr,

Test-Command: debian/tests/upstream-testsuite CPP/CUDA 17 g++-11
Features: test-name=compile_testsuite_CPP_CUDA_C++17_g++-11
Architecture: amd64
Depends:
 @,
 cmake,
 make,
 libtbb-dev,
 g++-11,
 nvidia-cuda-toolkit-gcc,
Restrictions:
 superficial,
 allow-stderr,
 flaky,
 skippable,

Test-Command: debian/tests/upstream-testsuite TBB/CUDA 17 g++-11
Features: test-name=compile_testsuite_TBB_CUDA_C++17_g++-11
Architecture: amd64
Depends:
 @,
 cmake,
 make,
 libtbb-dev,
 g++-11,
 nvidia-cuda-toolkit-gcc,
Restrictions:
 superficial,
 allow-stderr,
 flaky,
 skippable,

Test-Command: debian/tests/upstream-testsuite CPP/CUDA 17 g++-10
Features: test-name=compile_testsuite_CPP_CUDA_C++17_g++-10
Architecture: amd64
Depends:
 @,
 cmake,
 make,
 libtbb-dev,
 g++-10,
 nvidia-cuda-toolkit-gcc,
Restrictions:
 superficial,
 allow-stderr,
 flaky,
 skippable,

Test-Command: debian/tests/upstream-testsuite TBB/CUDA 17 g++-10
Features: test-name=compile_testsuite_TBB_CUDA_C++17_g++-10
Architecture: amd64
Depends:
 @,
 cmake,
 make,
 libtbb-dev,
 g++-10,
 nvidia-cuda-toolkit-gcc,
Restrictions:
 superficial,
 allow-stderr,
 flaky,
 skippable,

## libthrust 1.17.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -49,7 +49,13 @@
 option(THRUST_ENABLE_HEADER_TESTING "Test that all public headers compile." "ON")
 option(THRUST_ENABLE_TESTING "Build Thrust testing suite." "ON")
 option(THRUST_ENABLE_EXAMPLES "Build Thrust examples." "ON")
+option(THRUST_ENABLE_BENCHMARKS "Build Thrust runtime benchmarks." "OFF")
 option(THRUST_INCLUDE_CUB_CMAKE "Build CUB tests and examples. (Requires CUDA)." "OFF")
+
+# Mark this option as advanced for now. We'll revisit this later once the new
+# benchmarks are ready. For now, we just need to expose a way to compile
+# bench.cu from CMake for NVIDIA's internal builds.
+mark_as_advanced(THRUST_ENABLE_BENCHMARKS)
 
 # Check if we're actually building anything before continuing. If not, no need
 # to search for deps, etc. This is a common approach for packagers that just
@@ -57,6 +63,7 @@
 if (NOT (THRUST_ENABLE_HEADER_TESTING OR
          THRUST_ENABLE_TESTING OR
          THRUST_ENABLE_EXAMPLES OR
+         THRUST_ENABLE_BENCHMARKS OR
          THRUST_INCLUDE_CUB_CMAKE))
   return()
 endif()
@@ -118,6 +125,10 @@
   add_subdirectory(examples)
 endif()
 
+if (THRUST_ENABLE_BENCHMARKS)
+  add_subdirectory(internal/benchmark)
+endif()
+
 if (THRUST_INCLUDE_CUB_CMAKE AND THRUST_CUDA_FOUND)
   set(CUB_IN_THRUST ON)
   # CUB's path is specified generically to support both GitHub and Perforce

=== internal/benchmark/CMakeLists.txt ===
if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  # MSVC builds fail at runtime. Benchmarks are linux-only for now.
  message(STATUS "Thrust benchmarking is not available on MSVC.")
  return()
endif()

add_custom_target(thrust.all.bench)

foreach(thrust_target IN LISTS THRUST_TARGETS)
  thrust_get_target_property(config_host ${thrust_target} HOST)
  thrust_get_target_property(config_device ${thrust_target} DEVICE)
  thrust_get_target_property(config_prefix ${thrust_target} PREFIX)

  # Skip non cpp.cuda targets:
  if (NOT config_host   STREQUAL "CPP" OR
      NOT config_device STREQUAL "CUDA")
    continue()
  endif()

  set(bench_target ${config_prefix}.bench)

  add_executable(${bench_target} bench.cu)
  target_link_libraries(${bench_target} PRIVATE ${thrust_target})
  target_include_directories(${bench_target} PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}")
  thrust_clone_target_properties(${bench_target} ${thrust_target})

  add_dependencies(thrust.all.bench ${bench_target})
  add_dependencies(${config_prefix}.all ${bench_target})
endforeach()

=== testing/async/CMakeLists.txt ===
# The async tests perform a large amount of codegen, making them expensive to
# build and test. To keep compilation and runtimes manageable, the tests are
# broken up into many files per algorithm to enable parallelism during
# compilation and testing. The structure of these test directories are:
#
# thrust/testing/async/<algorithm_name>/<unit_test>.cu
#
# These generate executables and CTest tests named
# ${config_prefix}.test.async.<algorithm_name>.<unit_test>.

# The async tests only support CUDA enabled configs. Create a list of valid
# thrust targets:
set(cuda_configs)
foreach(thrust_target IN LISTS THRUST_TARGETS)
  thrust_get_target_property(config_device ${thrust_target} DEVICE)
  if (config_device STREQUAL CUDA)
    list(APPEND cuda_configs ${thrust_target})
  endif()
endforeach()

list(LENGTH cuda_configs num_cuda_configs)
if (num_cuda_configs EQUAL 0)
  return() # No valid configs found, nothing to do.
endif()

# Process a single algorithm directory, adding all .cu/cpp files as tests for
# each valid backend. algo_name is the name of the subdir (<algorithm_name>
# above) and is used for naming the executable/targets.
function(thrust_add_async_test_dir algo_name)
  file(GLOB test_srcs
    RELATIVE "${CMAKE_CURRENT_LIST_DIR}"
    CONFIGURE_DEPENDS
    "${algo_name}/*.cu"
    "${algo_name}/*.cpp"
  )

  # Per-algorithm, all-config metatarget: thrust.all.test.async.[algo].all
  set(algo_meta_target thrust.all.test.async.${algo_name}.all)
  add_custom_target(${algo_meta_target})

  foreach(thrust_target IN LISTS cuda_configs)
    thrust_get_target_property(config_prefix ${thrust_target} PREFIX)

    # Per-algorithm, per-config metatarget: thrust.[config].test.async.[algo].all
    set(algo_config_meta_target ${config_prefix}.test.async.${algo_name}.all)
    add_custom_target(${algo_config_meta_target})
    add_dependencies(${algo_meta_target} ${algo_config_meta_target})

    foreach(test_src IN LISTS test_srcs)
      get_filename_component(test_name "${test_src}" NAME_WLE)
      string(PREPEND test_name async.${algo_name}.)

      thrust_add_test(test_target ${test_name} "${test_src}" ${thrust_target})
      if(THRUST_ENABLE_TESTS_WITH_RDC)
        thrust_enable_rdc_for_cuda_target(${test_target})
      endif()

      add_dependencies(${algo_config_meta_target} ${test_target})
    endforeach()
  endforeach()
endfunction()

# Grab all algorithm subdirectories:
set(test_dirs)
file(GLOB contents
  CONFIGURE_DEPENDS
  "${CMAKE_CURRENT_LIST_DIR}/*"
)

foreach(test_dir IN LISTS contents)
  if(IS_DIRECTORY "${test_dir}")
    list(APPEND test_dirs "${test_dir}")
  endif()
endforeach()

# Process all test dirs:
foreach(test_dir IN LISTS test_dirs)
  get_filename_component(algo_name "${test_dir}" NAME_WLE)
  thrust_add_async_test_dir(${algo_name})
endforeach()

=== debian/changelog ===
libthrust (1.17.2-2) unstable; urgency=medium

  * Stop testing with g++-10.
  * Bump Standards-Version to 4.6.2, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 21 Feb 2023 11:44:15 +0100

libthrust (1.17.2-1) unstable; urgency=medium

  * New upstream release 1.17.2.
  * Install *.cmake to CMAKE_INSTALL_DATADIR.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 23 Dec 2022 20:56:18 +0100

libthrust (1.16.0-2) unstable; urgency=medium

  * Mark TBB/CUDA test as flaky.  (Closes: #1016711)
  * Update watch file.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 11 Nov 2022 12:11:17 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  debhelper-compat (= 13),
  cmake,
 Rules-Requires-Root: no
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/NVIDIA/thrust
 Vcs-Browser: https://salsa.debian.org/nvidia-team/libthrust
 Vcs-Git: https://salsa.debian.org/nvidia-team/libthrust.git

=== debian/rules ===
--- 
+++ 
@@ -20,7 +20,6 @@
 	dh_auto_install --destdir=debian/tmp
 
 execute_after_dh_auto_install:
-	$(RM) -v debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/thrust/thrust-header-search.cmake.in
 	# remove empty directories
 	find debian/tmp -depth -type d -exec sh -c 'd="{}"; rmdir --ignore-fail-on-non-empty "$$d" ; test -d "$$d" || echo "removed $$d"' \;

## libthrust 2.0.1

=== Makefile ===
# Copyright 2010-2020 NVIDIA Corporation.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#		http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Makefile for building Thrust unit test driver

# Force C++11 mode. NVCC will ignore it if the host compiler doesn't support it.
export CXX_STD := c++11

export CCCL_ENABLE_DEPRECATIONS := 1

export VERBOSE := 1

ifndef PROFILE
  ifdef VULCAN_TOOLKIT_BASE
    include $(VULCAN_TOOLKIT_BASE)/build/getprofile.mk
    include $(VULCAN_TOOLKIT_BASE)/build/config/$(PROFILE).mk
  else
    include ../build/getprofile.mk
    include ../build/config/$(PROFILE).mk
  endif
endif

SOLNDIR := .

ifdef VULCAN_TOOLKIT_BASE
  include $(VULCAN_TOOLKIT_BASE)/build/config/DetectOS.mk
else
  include ../build/config/DetectOS.mk
endif

TMP_DIR      := built
TMP_PREFIX   := $(ROOTDIR)
TMP_ARCH     := $(ARCH)_$(PROFILE)_agnostic
THRUST_MKDIR := $(TMP_PREFIX)/$(TMP_DIR)/$(TMP_ARCH)/thrust/mk
THRUST_DIR   := $(ROOTDIR)/thrust

res:=$(shell $(PYTHON) ./generate_mk.py $(THRUST_MKDIR) $(THRUST_DIR))

# Use these environment variables to control what gets built:
#
#   TEST_ALL
#   TEST_UNITTESTS
#   TEST_EXAMPLES
#   TEST_BENCH
#   TEST_OTHER

ifneq ($(TEST_ALL),)
  override TEST_UNITTESTS := 1
  override TEST_EXAMPLES := 1
  override TEST_BENCH := 1
  override TEST_OTHER := 1
endif

ifeq ($(TEST_UNITTESTS)$(TEST_EXAMPLES)$(TEST_BENCH)$(TEST_OTHER),)
  override TEST_UNITTESTS := 1
  override TEST_EXAMPLES := 1
  override TEST_BENCH := 1
  override TEST_OTHER := 1
endif

ifneq ($(TEST_OTHER),)
  PROJECTS += internal/build/warningstester
endif

ifneq ($(TEST_BENCH),)
  PROJECTS += internal/benchmark/bench
endif

ifneq ($(TEST_UNITTESTS),)
  # copy existing projects
  PROJECTS_COPY := $(PROJECTS)

  # empty PROJECTS
  PROJECTS :=

  # populate PROJECTS with unit tests.
  include $(THRUST_MKDIR)/testing.mk

  # Once PROJECTS is populated with unit tests, re-add the previous projects.
  PROJECTS += $(PROJECTS_COPY)
endif

ifneq ($(TEST_EXAMPLES),)
  # Copy existing projects.
  PROJECTS_COPY := $(PROJECTS)

  # Empty PROJECTS.
  PROJECTS :=

  # Populate PROJECTS with examples.
  include $(THRUST_MKDIR)/examples.mk

  # Once PROJECTS is populated with examples, re-add the previous projects.
  PROJECTS += $(PROJECTS_COPY)
endif

ifdef VULCAN_TOOLKIT_BASE
  include $(VULCAN_TOOLKIT_BASE)/build/common.mk
else
  include ../build/common.mk
endif

ifeq ($(OS), win32)
  CREATE_DVS_PACKAGE = $(ZIP) -r built/CUDA-thrust-package.zip bin thrust/internal/test thrust/internal/scripts thrust/internal/benchmark $(DVS_COMMON_TEST_PACKAGE_FILES)
  APPEND_H_DVS_PACKAGE = $(ZIP) -rg built/CUDA-thrust-package.zip thrust -9 -i *.h
  APPEND_INL_DVS_PACKAGE = $(ZIP) -rg built/CUDA-thrust-package.zip thrust -9 -i *.inl
  APPEND_CUH_DVS_PACKAGE = $(ZIP) -rg built/CUDA-thrust-package.zip thrust -9 -i *.cuh
  MAKE_DVS_PACKAGE = $(CREATE_DVS_PACKAGE) && $(APPEND_H_DVS_PACKAGE) && $(APPEND_INL_DVS_PACKAGE) && $(APPEND_CUH_DVS_PACKAGE)
else
  TAR_FILES = bin thrust/internal/test thrust/internal/scripts thrust/internal/benchmark $(DVS_COMMON_TEST_PACKAGE_FILES)
  TAR_FILES += `find -L thrust \( -name "*.cuh" -o -name "*.h" -o -name "*.inl" \)`
  MAKE_DVS_PACKAGE = tar -I lbzip2 -chvf built/CUDA-thrust-package.tar.bz2 $(TAR_FILES)
endif

COPY_CUB_FOR_PACKAGING = rm -rf cub && cp -rp ../cub/cub cub

DVS_OPTIONS :=

ifneq ($(TARGET_ARCH),$(HOST_ARCH))
  DVS_OPTIONS += TARGET_ARCH=$(TARGET_ARCH)
endif
ifeq ($(TARGET_ARCH),ARMv7)
  DVS_OPTIONS += ABITYPE=$(ABITYPE)
endif

THRUST_DVS_BUILD = release

pack:
	$(COPY_CUB_FOR_PACKAGING)
	cd .. && $(MAKE_DVS_PACKAGE)

dvs:
	$(COPY_CUB_FOR_PACKAGING)
# Build the CUDA Runtime in GVS, because GVS has no CUDA Runtime component.
# This is a temporary workaround until the Tegra team adds a CUDA Runtime
# component, which they have promised to do.
ifdef GVS
	$(MAKE) $(DVS_OPTIONS) -s -C ../cuda $(THRUST_DVS_BUILD)
endif
	$(MAKE) $(DVS_OPTIONS) $(THRUST_DVS_BUILD) THRUST_DVS=1
	cd .. && $(MAKE_DVS_PACKAGE)

dvs_release:
	$(MAKE) dvs THRUST_DVS_BUILD=release

dvs_debug:
	$(MAKE) dvs THRUST_DVS_BUILD=debug

include $(THRUST_MKDIR)/dependencies.mk

=== examples/CMakeLists.txt ===
# Setup FileCheck if requested and available:
option(THRUST_ENABLE_EXAMPLE_FILECHECK
  "Check example output with the LLVM FileCheck utility."
  OFF
)
set(filecheck_data_path "${Thrust_SOURCE_DIR}/internal/test")

if (THRUST_ENABLE_EXAMPLE_FILECHECK)
  # TODO this should go into a find module
  find_program(THRUST_FILECHECK_EXECUTABLE
    DOC "Path to the LLVM FileCheck utility."
    NAMES
      FileCheck
      FileCheck-3.9
      FileCheck-4.0
      FileCheck-5.0
      FileCheck-6.0
      FileCheck-7
      FileCheck-8
      FileCheck-9
  )

  if (NOT THRUST_FILECHECK_EXECUTABLE)
    message(FATAL_ERROR
      "Could not find the LLVM FileCheck utility. Set THRUST_FILECHECK_EXECUTABLE manually, "
      "or disable THRUST_ENABLE_EXAMPLE_FILECHECK."
    )
  endif()

  execute_process(
    COMMAND "${THRUST_FILECHECK_EXECUTABLE}" "${filecheck_data_path}/thrust.smoke.filecheck"
    INPUT_FILE "${Thrust_SOURCE_DIR}/cmake/filecheck_smoke_test"
    RESULT_VARIABLE exit_code
  )

  if (0 EQUAL exit_code)
    message(STATUS "FileCheck enabled: ${THRUST_FILECHECK_EXECUTABLE}")
  else()
    message(FATAL_ERROR
      "The current THRUST_FILECHECK_EXECUTABLE ('${THRUST_FILECHECK_EXECUTABLE}') "
      "does not seem to be a valid FileCheck executable."
    )
  endif()
endif()

# Create meta targets that build all examples for a single configuration:
foreach(thrust_target IN LISTS THRUST_TARGETS)
  thrust_get_target_property(config_prefix ${thrust_target} PREFIX)
  set(config_meta_target ${config_prefix}.examples)
  add_custom_target(${config_meta_target})
  add_dependencies(${config_prefix}.all ${config_meta_target})
endforeach()

# Update flags to reflect RDC options. See note in ThrustCudaConfig.cmake --
# these flag variables behave unintuitively:
if (THRUST_ENABLE_EXAMPLES_WITH_RDC)
  set(CMAKE_CUDA_FLAGS "${THRUST_CUDA_FLAGS_BASE} ${THRUST_CUDA_FLAGS_RDC}")
else()
  set(CMAKE_CUDA_FLAGS "${THRUST_CUDA_FLAGS_BASE} ${THRUST_CUDA_FLAGS_NO_RDC}")
endif()

## thrust_add_example
#
# Add an example executable and register it with ctest.
#
# target_name_var: Variable name to overwrite with the name of the example
#   target. Useful for post-processing target information per-backend.
# example_name: The name of the example minus "<config_prefix>.example." For
#   instance, examples/vector.cu will be "vector", and examples/cuda/copy.cu
#   would be "cuda.copy".
# example_src: The source file that implements the example.
# thrust_target: The reference thrust target with configuration information.
#
function(thrust_add_example target_name_var example_name example_src thrust_target)
  thrust_get_target_property(config_host ${thrust_target} HOST)
  thrust_get_target_property(config_device ${thrust_target} DEVICE)
  thrust_get_target_property(config_prefix ${thrust_target} PREFIX)

  # Wrap the .cu file in .cpp for non-CUDA backends
  if ("CUDA" STREQUAL "${config_device}")
    set(real_example_src "${example_src}")
  else()
    thrust_wrap_cu_in_cpp(real_example_src "${example_src}" ${thrust_target})
  endif()

  # The actual name of the test's target:
  set(example_target ${config_prefix}.example.${example_name})
  set(${target_name_var} ${example_target} PARENT_SCOPE)

  # Related target names:
  set(config_meta_target ${config_prefix}.examples)
  set(example_meta_target thrust.all.example.${example_name})

  add_executable(${example_target} "${real_example_src}")
  target_link_libraries(${example_target} ${thrust_target})
  target_include_directories(${example_target} PRIVATE "${Thrust_SOURCE_DIR}/examples")
  thrust_clone_target_properties(${example_target} ${thrust_target})

  # Add to the active configuration's meta target
  add_dependencies(${config_meta_target} ${example_target})

  # Meta target that builds examples with this name for all configurations:
  if (NOT TARGET ${example_meta_target})
    add_custom_target(${example_meta_target})
  endif()
  add_dependencies(${example_meta_target} ${example_target})

  if ("CUDA" STREQUAL "${config_device}" AND
      THRUST_ENABLE_EXAMPLES_WITH_RDC)
    thrust_enable_rdc_for_cuda_target(${example_target})
  endif()

  # Get the name of FileCheck input by stripping out the config name.
  # (e.g. "thrust.cpp.cuda.cpp14.example.xxx" -> "thrust.example.xxx.filecheck")
  string(REPLACE "${config_prefix}" "thrust"
    filecheck_reference_file
    "${example_target}.filecheck"
  )

  add_test(NAME ${example_target}
    COMMAND "${CMAKE_COMMAND}"
    "-DEXAMPLE_EXECUTABLE=$<TARGET_FILE:${example_target}>"
    "-DFILECHECK_ENABLED=${THRUST_ENABLE_EXAMPLE_FILECHECK}"
    "-DFILECHECK_EXECUTABLE=${THRUST_FILECHECK_EXECUTABLE}"
    "-DREFERENCE_FILE=${filecheck_data_path}/${filecheck_reference_file}"
    -P "${Thrust_SOURCE_DIR}/cmake/ThrustRunExample.cmake"
  )

  # Run OMP/TBB tests in serial. Multiple OMP processes will massively
  # oversubscribe the machine with GCC's OMP, and we want to test these with
  # the full CPU available to each unit test.
  set(config_systems ${config_host} ${config_device})
  if (("OMP" IN_LIST config_systems) OR ("TBB" IN_LIST config_systems))
    set_tests_properties(${example_target} PROPERTIES RUN_SERIAL ON)
  endif()
endfunction()

file(GLOB example_srcs
  RELATIVE "${CMAKE_CURRENT_LIST_DIR}"
  CONFIGURE_DEPENDS
  *.cu *.cpp
)

foreach(thrust_target IN LISTS THRUST_TARGETS)
  foreach(example_src IN LISTS example_srcs)
    get_filename_component(example_name "${example_src}" NAME_WLE)
    thrust_add_example(example_target ${example_name} "${example_src}" ${thrust_target})
  endforeach()
endforeach()

add_subdirectory(cmake)
add_subdirectory(cuda)

=== examples/cmake/CMakeLists.txt ===
thrust_update_system_found_flags()

set(extra_cmake_flags)

# Need to pass these when testing NVC++.
if ("NVCXX" STREQUAL "${CMAKE_CUDA_COMPILER_ID}")
  set(extra_cmake_flags
    -D "CMAKE_CUDA_COMPILER_ID=${CMAKE_CUDA_COMPILER_ID}"
    -D "CMAKE_CUDA_COMPILER_FORCED=${CMAKE_CUDA_COMPILER_FORCED}"
  )
endif()

if (THRUST_CPP_FOUND AND THRUST_CUDA_FOUND)
  # Do a basic check of the cmake/ThrustAddSubdir.cmake mechanism:
  add_test(
    NAME thrust.example.cmake.add_subdir
    COMMAND "${CMAKE_COMMAND}"
      --log-level=VERBOSE
      -G "${CMAKE_GENERATOR}"
      -S "${CMAKE_CURRENT_SOURCE_DIR}/add_subdir"
      -B "${CMAKE_CURRENT_BINARY_DIR}/add_subdir"
      -D "THRUST_ROOT=${Thrust_SOURCE_DIR}"
      -D "CMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
      -D "CMAKE_CUDA_COMPILER=${CMAKE_CUDA_COMPILER}"
      -D "CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}"
      ${extra_cmake_flags}
  )
endif()

=== examples/cmake/add_subdir/CMakeLists.txt ===
# This example demonstrates / tests adding thrust via a CMake add_subdirectory
# call from a parent project.
#
# The variables THRUST_REQUIRED_SYSTEMS and THRUST_OPTIONAL_SYSTEMS must be
# set prior to add_subdirectory(thrust), and afterwards the thrust_create_target
# function may be used to create targets with the desired systems. See
# NVIDIA/thrust/cmake/README.md for more details on thrust_create_target.

cmake_minimum_required(VERSION 3.15)

# Silence warnings about empty CUDA_ARCHITECTURES properties on example targets:
if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.18)
  cmake_policy(SET CMP0104 OLD)
endif()

project(ThrustAddSubDirExample CXX)

# Add required Thrust systems to THRUST_REQUIRED_SYSTEMS.
# Options are: CPP, CUDA, TBB or OMP.
# Multiple systems may be specified.
# An error is emitted if the system is not found.
set(THRUST_REQUIRED_SYSTEMS CPP)

# Add optional Thrust systems to THRUST_OPTIONAL_SYSTEMS.
# Options are: CPP, CUDA, TBB or OMP.
# Multiple systems may be specified.
# No error is emitted if not found.
set(THRUST_OPTIONAL_SYSTEMS CUDA)

# Use your project's checkout of Thrust here, for most cases
# `add_subdirectory(thrust)` will be sufficient.
add_subdirectory("${THRUST_ROOT}" thrust)

# Create a thrust target that only uses the serial CPP backend.
# See thrust/thrust/cmake/README.md for details and additional options:
thrust_create_target(ThrustCPP HOST CPP DEVICE CPP)

# Create an executable that uses the CPP-only thrust target:
add_executable(ExecWithCPP dummy.cpp)
target_link_libraries(ExecWithCPP ThrustCPP)

# To test for optional systems, first call thrust_update_system_found_flags to
# set the THRUST_${system}_FOUND flags in current scope.
# Required due to CMake scoping rules.
thrust_update_system_found_flags()

# Create and use a Thrust target configured to use CUDA acceleration if CUDA
# is available:
if (THRUST_CUDA_FOUND)
  enable_language(CUDA)
  thrust_create_target(ThrustCUDA HOST CPP DEVICE CUDA)
  add_executable(ExecWithCUDA dummy.cu)
  target_link_libraries(ExecWithCUDA ThrustCUDA)
endif()

#
# Validation
#

function(assert_boolean var_name expect)
  if (expect)
    if (NOT ${var_name})
      message(FATAL_ERROR "'${var_name}' is false, expected true.")
    endif()
  else()
    if (${var_name})
      message(FATAL_ERROR "'${var_name}' is true, expected false.")
    endif()
  endif()
endfunction()

function(assert_target target_name)
  if (NOT TARGET "${target_name}")
    message(FATAL_ERROR "Target '${target_name}' not defined.")
  endif()
endfunction()

assert_boolean(THRUST_CPP_FOUND TRUE)
assert_boolean(THRUST_CUDA_FOUND TRUE)
assert_boolean(THRUST_OMP_FOUND FALSE)
assert_boolean(THRUST_TBB_FOUND FALSE)

assert_target(ThrustCPP)
assert_target(ThrustCUDA)
assert_target(ExecWithCPP)
assert_target(ExecWithCUDA)

thrust_debug_target(ThrustCPP "")
thrust_debug_target(ThrustCUDA "")
thrust_debug_target(ExecWithCPP "")
thrust_debug_target(ExecWithCUDA "")

=== testing/cmake/test_install/CMakeLists.txt ===
# Test that an installation of the project can be located by find_package() call
# with appropriate prefix settings.
#
# Expects THRUST_BINARY_DIR to be set to an existing thrust build directory.

cmake_minimum_required(VERSION 3.15)

project(ThrustTestInstall CXX CUDA)

# This will eventually get deleted recursively -- keep that in mind if modifying
set(CMAKE_INSTALL_PREFIX "${CMAKE_CURRENT_BINARY_DIR}/install_prefix/")

function(do_manual_install)
  # Inspired by the VTK-m install tests, we can just glob up all of the
  # cmake_install.cmake, include (ie. run) them, and they'll effectively
  # install the project into the current value of CMAKE_INSTALL_PREFIX.

  # Gather all of the install files from Thrust's root:
  file(GLOB_RECURSE install_files
    LIST_DIRECTORIES False
    "${THRUST_BINARY_DIR}/cmake_install.cmake"
  )

  message(STATUS "Locating install files...")
  foreach (install_file IN LISTS install_files)
    message(STATUS "  * ${install_file}")
  endforeach()

  message(STATUS "Building install tree...")
  foreach(install_file IN LISTS install_files)
    include("${install_file}")
  endforeach()
endfunction()

function(do_cleanup)
  message(STATUS "Removing ${CMAKE_INSTALL_PREFIX}")
  file(REMOVE_RECURSE "${CMAKE_INSTALL_PREFIX}")
endfunction()

function(assert_boolean var_name expect)
  if (expect)
    if (NOT ${var_name})
      message(FATAL_ERROR "'${var_name}' is false, expected true.")
    endif()
  else()
    if (${var_name})
      message(FATAL_ERROR "'${var_name}' is true, expected false.")
    endif()
  endif()
endfunction()

function(assert_target target_name)
  if (NOT TARGET "${target_name}")
    message(FATAL_ERROR "Target '${target_name}' not defined.")
  endif()
endfunction()

function(find_installed_project)
  set(CMAKE_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}")
  find_package(Thrust CONFIG COMPONENTS CPP CUDA)

  if (NOT Thrust_FOUND)
    message(FATAL_ERROR
      "find_package(Thrust) failed. "
      "CMAKE_PREFIX_PATH=${CMAKE_PREFIX_PATH}"
    )
  endif()

  # Test some internal config vars to check that this is the expected install:
  # TODO The cmake_path (3.19) command will provide more robust ways to do this

  # Escape regex special characters in the install prefix, see
  # https://gitlab.kitware.com/cmake/cmake/-/issues/18580
  string(REGEX REPLACE "([][+.*()^])" "\\\\\\1"
    prefix_regex
    "${CMAKE_INSTALL_PREFIX}"
  )
  if (NOT _THRUST_INCLUDE_DIR MATCHES "^${prefix_regex}")
    message(FATAL_ERROR
      "Found Thrust in unexpected location: "
      " * _THRUST_INCLUDE_DIR=${_THRUST_INCLUDE_DIR} "
      " * ExpectedPrefix=${CMAKE_INSTALL_DIR}"
    )
  endif()
  if (NOT _CUB_INCLUDE_DIR MATCHES "^${prefix_regex}")
    message(FATAL_ERROR
      "Found CUB in unexpected location: "
      " * _CUB_INCLUDE_DIR=${_CUB_INCLUDE_DIR} "
      " * ExpectedPrefix=${CMAKE_INSTALL_DIR}"
    )
  endif()

  thrust_create_target(Thrust)
  assert_target(Thrust)
  assert_target(CUB::CUB)
  assert_target(Thrust::CPP::Host)
  assert_target(Thrust::CUDA::Device)

  thrust_update_system_found_flags()
  assert_boolean(THRUST_CPP_FOUND TRUE)
  assert_boolean(THRUST_CUDA_FOUND TRUE)
  assert_boolean(THRUST_OMP_FOUND FALSE)
  assert_boolean(THRUST_TBB_FOUND FALSE)

endfunction()

do_cleanup() # Prepare for new installation
do_manual_install()
find_installed_project()
do_cleanup() # Clean up if successful

=== debian/changelog ===
libthrust (2.0.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 15 Jun 2023 10:31:22 +0200

libthrust (2.0.1-1) experimental; urgency=medium

  * New upstream release 2.0.1.
  * Add (Build-)Depends: libcu++-dev (>= 1.8.0).
  * Fix autopkgtests with older nvcc.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 17 Mar 2023 16:53:41 +0100

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
+ libcu++-dev (>= 1.8.0),
 Rules-Requires-Root: no
 Standards-Version: 4.6.2
 Homepage: https://github.com/NVIDIA/thrust
@@ -19,6 +20,7 @@
 Depends:
  libcub-dev (>= ${cub:Version}),
  libcub-dev (<< ${cub:Version}.),
+ libcu++-dev (>= 1.8.0),
  ${misc:Depends}
 Recommends:
  libtbb-dev,

=== debian/rules ===
--- 
+++ 
@@ -13,6 +13,7 @@
 		-DTHRUST_DEVICE_SYSTEM=CPP \
 		-DTHRUST_CPP_DIALECT=17 \
 		-DTHRUST_INSTALL_CUB_HEADERS=OFF \
+		-DTHRUST_INSTALL_LIBCUDACXX_HEADERS=OFF \
 		-Wno-dev
 
 # for debhelper-compat (<< 15)

=== debian/tests/control ===
--- 
+++ 
@@ -29,19 +29,6 @@
  make,
  libtbb-dev,
  g++-11,
-Restrictions:
- superficial,
- allow-stderr,
- flaky,
-
-Test-Command: debian/tests/upstream-testsuite CPP 17 g++-10
-Features: test-name=run_testsuite_CPP_C++17_g++-10
-Depends:
- @,
- cmake,
- make,
- libtbb-dev,
- g++-10,
 Restrictions:
  superficial,
  allow-stderr,
@@ -98,6 +85,7 @@
 Restrictions:
  superficial,
  allow-stderr,
+ flaky,
 
 Test-Command: debian/tests/upstream-testsuite CPP/CUDA 17 g++-11
 Features: test-name=compile_testsuite_CPP_CUDA_C++17_g++-11
@@ -131,35 +119,3 @@
  flaky,
  skippable,
 
-Test-Command: debian/tests/upstream-testsuite CPP/CUDA 17 g++-10
-Features: test-name=compile_testsuite_CPP_CUDA_C++17_g++-10
-Architecture: amd64
-Depends:
- @,
- cmake,
- make,
- libtbb-dev,
- g++-10,
- nvidia-cuda-toolkit-gcc,
-Restrictions:
- superficial,
- allow-stderr,
- flaky,
- skippable,
-
-Test-Command: debian/tests/upstream-testsuite TBB/CUDA 17 g++-10
-Features: test-name=compile_testsuite_TBB_CUDA_C++17_g++-10
-Architecture: amd64
-Depends:
- @,
- cmake,
- make,
- libtbb-dev,
- g++-10,
- nvidia-cuda-toolkit-gcc,
-Restrictions:
- superficial,
- allow-stderr,
- flaky,
- skippable,
-

## libthrust 2.1.0

=== debian/changelog ===
libthrust (2.1.0-1) unstable; urgency=medium

  * New upstream release 2.1.0.  (Closes: #1074279)
  * Bump Standards-Version to 4.7.0, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 26 Jun 2024 00:09:14 +0200
